org.apache.jasper.xmlparser

## Class XMLEncodingDetector

- java.lang.Object
- - org.apache.jasper.xmlparser.XMLEncodingDetector

- Deprecated.
  Will be removed in Tomcat 9.0.x onwards

      @Deprecated
      public class XMLEncodingDetector
      extends Object

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `XMLEncodingDetector()` Deprecated. Constructor

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static Object[]` | `getEncoding(String fname, Jar jar, JspCompilationContext ctxt, ErrorDispatcher err)` Deprecated. Autodetects the encoding of the XML document supplied by the given input stream.
    `boolean` | `isExternal()` Deprecated.
    `int` | `peekChar()` Deprecated. Returns the next character on the input.
    `int` | `scanChar()` Deprecated. Returns the next character on the input.
    `boolean` | `scanData(String delimiter, XMLStringBuffer buffer)` Deprecated. Scans a range of character data up to the specified delimiter, setting the fields of the XMLString structure, appropriately.
    `int` | `scanLiteral(int quote, XMLString content)` Deprecated. Scans a range of attribute value data, setting the fields of the XMLString structure, appropriately.
    `String` | `scanName()` Deprecated. Returns a string matching the Name production appearing immediately on the input as a symbol, or null if no Name string is present.
    `String` | `scanPseudoAttribute(boolean scanningTextDecl, XMLString value)` Deprecated. Scans a pseudo attribute.
    `boolean` | `skipChar(int c)` Deprecated. Skips a character appearing immediately on the input.
    `boolean` | `skipSpaces()` Deprecated. Skips space characters appearing immediately on the input.
    `boolean` | `skipString(String s)` Deprecated. Skips the specified string appearing immediately on the input.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### XMLEncodingDetector

          public XMLEncodingDetector()

      Deprecated.
      Constructor

  - ### Method Detail

    - #### getEncoding

          public static Object[] getEncoding(String fname,
                             Jar jar,
                             JspCompilationContext ctxt,
                             ErrorDispatcher err)
                                      throws IOException,
                                             JasperException

      Deprecated.
      Autodetects the encoding of the XML document supplied by the given input stream. Encoding autodetection is done according to the XML 1.0 specification, Appendix F.1: Detection Without External Encoding Information.
      Parameters:
        `fname` - The file name
        `jar` - The containing jar
        `ctxt` - The compilation context
        `err` - The error dispatcher
      Returns:
        Two-element array, where the first element (of type java.lang.String) contains the name of the (auto)detected encoding, and the second element (of type java.lang.Boolean) specifies whether the encoding was specified using the 'encoding' attribute of an XML prolog (TRUE) or autodetected (FALSE).
      Throws:
        `IOException` - Error reading resource
        `JasperException` - Other error, usually a bad encoding

    - #### isExternal

          public boolean isExternal()

      Deprecated.
      Returns:
        `true` if the current entity being scanned is external.

    - #### peekChar

          public int peekChar()
                       throws IOException

      Deprecated.
      Returns the next character on the input.

      Note: The character is not consumed.

      Returns:
        the next char
      Throws:
        `IOException` - Thrown if i/o error occurs.
        `EOFException` - Thrown on end of file.

    - #### scanChar

          public int scanChar()
                       throws IOException

      Deprecated.
      Returns the next character on the input.

      Note: The character is consumed.

      Returns:
        the next char
      Throws:
        `IOException` - Thrown if i/o error occurs.
        `EOFException` - Thrown on end of file.

    - #### scanName

          public String scanName()
                          throws IOException

      Deprecated.
      Returns a string matching the Name production appearing immediately on the input as a symbol, or null if no Name string is present.

      Note: The Name characters are consumed.

      Note: The string returned must be a symbol. The SymbolTable can be used for this purpose.

      Returns:
        the name
      Throws:
        `IOException` - Thrown if i/o error occurs.
        `EOFException` - Thrown on end of file.
      See Also:
        `SymbolTable`, `XMLChar.isName(int)`, `XMLChar.isNameStart(int)`

    - #### scanLiteral

          public int scanLiteral(int quote,
                        XMLString content)
                          throws IOException

      Deprecated.
      Scans a range of attribute value data, setting the fields of the XMLString structure, appropriately.

      Note: The characters are consumed.

      Note: This method does not guarantee to return the longest run of attribute value data. This method may return before the quote character due to reaching the end of the input buffer or any other reason.

      Note: The fields contained in the XMLString structure are not guaranteed to remain valid upon subsequent calls to the entity scanner. Therefore, the caller is responsible for immediately using the returned character data or making a copy of the character data.

      Parameters:
        `quote` - The quote character that signifies the end of the attribute value data.
        `content` - The content structure to fill.
      Returns:
        Returns the next character on the input, if known. This value may be -1 but this does note designate end of file.
      Throws:
        `IOException` - Thrown if i/o error occurs.
        `EOFException` - Thrown on end of file.

    - #### scanData

          public boolean scanData(String delimiter,
                         XMLStringBuffer buffer)
                           throws IOException

      Deprecated.
      Scans a range of character data up to the specified delimiter, setting the fields of the XMLString structure, appropriately.

      Note: The characters are consumed.

      Note: This assumes that the internal buffer is at least the same size, or bigger, than the length of the delimiter and that the delimiter contains at least one character.

      Note: This method does not guarantee to return the longest run of character data. This method may return before the delimiter due to reaching the end of the input buffer or any other reason.

      Note: The fields contained in the XMLString structure are not guaranteed to remain valid upon subsequent calls to the entity scanner. Therefore, the caller is responsible for immediately using the returned character data or making a copy of the character data.

      Parameters:
        `delimiter` - The string that signifies the end of the character data to be scanned.
        `buffer` - The data structure to fill.
      Returns:
        `true` if there is more data to scan, `false` otherwise.
      Throws:
        `IOException` - Thrown if i/o error occurs.
        `EOFException` - Thrown on end of file.

    - #### skipChar

          public boolean skipChar(int c)
                           throws IOException

      Deprecated.
      Skips a character appearing immediately on the input.

      Note: The character is consumed only if it matches the specified character.

      Parameters:
        `c` - The character to skip.
      Returns:
        `true` if the character was skipped.
      Throws:
        `IOException` - Thrown if i/o error occurs.
        `EOFException` - Thrown on end of file.

    - #### skipSpaces

          public boolean skipSpaces()
                             throws IOException

      Deprecated.
      Skips space characters appearing immediately on the input.

      Note: The characters are consumed only if they are space characters.

      Returns:
        `true` if at least one space character was skipped.
      Throws:
        `IOException` - Thrown if i/o error occurs.
        `EOFException` - Thrown on end of file.
      See Also:
        `XMLChar.isSpace(int)`

    - #### skipString

          public boolean skipString(String s)
                             throws IOException

      Deprecated.
      Skips the specified string appearing immediately on the input.

      Note: The characters are consumed only if they are space characters.

      Parameters:
        `s` - The string to skip.
      Returns:
        `true` if the string was skipped.
      Throws:
        `IOException` - Thrown if i/o error occurs.
        `EOFException` - Thrown on end of file.

    - #### scanPseudoAttribute

          public String scanPseudoAttribute(boolean scanningTextDecl,
                                   XMLString value)
                                     throws IOException,
                                            JasperException

      Deprecated.
      Scans a pseudo attribute. Note: This method uses fStringBuffer2, anything in it at the time of calling is lost.
      Parameters:
        `scanningTextDecl` - True if scanning this pseudo-attribute for a TextDecl; false if scanning XMLDecl. This flag is needed to report the correct type of error.
        `value` - The string to fill in with the attribute value.
      Returns:
        The name of the attribute
      Throws:
        `IOException` - Error reading data
        `JasperException` - Other error

Copyright © 2000-2021 Apache Software Foundation. All Rights Reserved.